/* This applet is purposely for LiveConnect Java to JavaScript test.
 * Written by : Leila Garin      
 */

import java.awt.*;
import java.applet.Applet;
import netscape.javascript.JSObject;

public class JavaToJS extends Applet {

   final short SHORT = 0;
   final short INT = 1;
   final short DOUBLE = 3;
   final short FLOAT = 4;
   final short LONG = 5;
   final short CHAR = 6;
   final short BOOLEAN = 7;
   final short BYTE = 8;
   final short STRING = 9;
   final short ARRLEN = 5;
   final short MAXVAL = 0;
   final short MINVAL = 1;

   String message, testName;
   JSObject win, doc = null;
   
   public void init() {
      message = "From Java to JavaScript";
     try {
         win = JSObject.getWindow(this);
         doc = (JSObject)win.getMember("document");
      } catch (Exception e) {
         System.out.println(" COuld not get Window Object  " + e);
         System.out.println(" ! Exception caught ! ");
         System.out.println(">>>>>> TEST FAILED ");
         return;
      }

      if (win != null) {
         System.out.println(" JSObject.getWindow(this) is not NULL");
      } else {
         System.out.println(" JSObject.getWindow(this) is NULL");
      }

      if (doc != null) {
         System.out.println(" win.getMember(document) is not NULL");
      } else {
         System.out.println(" win.getMember(document) is NULL");
      }
      int index = 0;
      testName = getParameter("TestMethod");

      if(testName.equals("getWindow")){
         System.out.println("\n******** Testing getWindow() METHOD ********\n");
         getWindowTest();
      }
      if(testName.equals("getMember")){
         System.out.println("\n******** Testing getMember() METHOD ********\n");
         getMemberTest("getMember");
      }
      if(testName.equals("call")){
         System.out.println("\n******** Testing call() METHOD ********\n");
         callTest();
      }
      if(testName.equals("eval")){
         System.out.println("\n******** Testing eval() METHOD ********\n");
         evalTest();
      }
      if(testName.equals("getSlot")){
         System.out.println("\n******** Testing getSlot() METHOD ********\n");
         getSlotTest();
      }
      if(testName.equals("toString")){
         System.out.println("\n******** Testing toString() METHOD ********\n");
         toStringTest();
      }
      if(testName.equals("setSlotTest")){
         System.out.println("==================================");
         System.out.println("\n******** Testing setSlot() METHOD ********\n");
         setSlotTest();
      }
      if(testName.equals("setMemberTest")){
         System.out.println("==================================");
         System.out.println("\n******** Testing setMember() METHOD ********\n");
         setMemberTest();
      }
      if(testName.equals("removeMemberTest")){
         System.out.println("==================================");
         System.out.println("\n******** Testing removeMember() METHOD ********\n");
         removeMemberTest();
      }

      if(testName.equals("ALL")){
         runAllTests();
      }
   }

   public void runAllTests() {
      System.out.println("\n******** Testing getWindow() METHOD ********\n");
      getWindowTest();
      System.out.println("\n******** Testing getMember() METHOD ********\n");
      getMemberTest("getMember");
      System.out.println("\n******** Testing call() METHOD ********\n");
      callTest();
      System.out.println("\n******** Testing eval() METHOD ********\n");
      evalTest();
      System.out.println("\n******** Testing getSlot() METHOD ********\n");
      getSlotTest();
      System.out.println("\n******** Testing toString() METHOD ********\n");
      toStringTest();
      System.out.println("\n******** Testing setSlotTest() METHOD ********\n");
      setSlotTest();
      System.out.println("\n******** Testing setMemberTest() METHOD ********\n");
      setMemberTest();
      System.out.println("\n******** Testing removeMemberTest() METHOD ********\n");
      removeMemberTest();
   }

   public void getWindowTest() {
      System.out.println("==================================");
      try {
         JSObject window = JSObject.getWindow(this);
         if (window != null) { 
            System.out.println("window object is " + window.toString());
            System.out.println(">>>>>> TEST PASSED ");
         } else {
            System.out.println(">>>>>> TEST FAILED ");
         }
      } catch (Exception e) {
         System.out.println(" !!!!!! Exception caught !!!!!! " + e);
         System.out.println(">>>>>> TEST FAILED >>> ");
         return;
      }
   }

   public void callTest() {
      doCallTest(STRING, MINVAL);
      doCallTest(STRING, MAXVAL);
      doCallTest(SHORT, MINVAL);
      doCallTest(SHORT, MAXVAL);
      doCallTest(INT, MINVAL);
      doCallTest(INT, MAXVAL);
      doCallTest(DOUBLE, MINVAL);
      doCallTest(DOUBLE, MAXVAL);
      doCallTest(FLOAT, MINVAL);
      doCallTest(FLOAT, MAXVAL);
      doCallTest(LONG, MINVAL);
      doCallTest(LONG, MAXVAL);
      doCallTest(CHAR, MINVAL);
      doCallTest(CHAR, MAXVAL);
      doCallTest(BOOLEAN, MINVAL);
      doCallTest(BOOLEAN, MAXVAL);
      doCallTest(BYTE, MINVAL);
      doCallTest(BYTE, MAXVAL);
   }

   public void doCallTest(short type, short value) {
      Object args[] = new Object[ARRLEN];
      Object ret = new Object();
      args[0] = setData(type, value);
      win.call("popAlert", args);
      try {
         ret = win.call("returnTest", args);
         System.out.println("PARAMETER is " + getObjectType(type) + " == " + args[0]);
         System.out.println("RETURN value is " + ret.getClass() + " == " + ret); 
      } catch (Exception e) {
         System.out.println(" !!!!!! Exception caught !!!!!! " + e);
         System.out.println(">>>>>> TEST FAILED >>>>>>>> ");
         return;
      }
      if(ret.equals(args[0])) {
         System.out.println(">>>>>> TEST PASSED ");
      } else {
         System.out.println(">>>>>> TEST FAILED ");
      }
   }

   public Object setData(short type, short value) {
      Object obj = new Object();
      String str = "";
      switch(type) {
      case STRING:
         if(value == MINVAL) {
            str = "";
         }
         if(value == MAXVAL) {
            str = "The quick brown fox jumps over the lazy dog.";
            str = str.concat("The quick brown fox jumps over the lazy dog.");
         }
         obj = (Object) str;
         break;
      case SHORT:
         if(value == MINVAL) {
           obj = (Object)(new Short(Short.MIN_VALUE)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Short(Short.MAX_VALUE));
         }
         break;
      case INT:
         if(value == MINVAL) {
           obj = (Object)(new Integer(Integer.MIN_VALUE)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Integer(Integer.MAX_VALUE));
         }
         break;
      case DOUBLE:
         if(value == MINVAL) {
           obj = (Object)(new Double(Double.MIN_VALUE)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Double(Double.MAX_VALUE));
         }
         break;
      case FLOAT:
         if(value == MINVAL) {
           obj = (Object)(new Float(Float.MIN_VALUE)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Float(Float.MAX_VALUE));
         }
         break;
      case LONG:
         if(value == MINVAL) {
           obj = (Object)(new Long(Long.MIN_VALUE)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Long(Long.MAX_VALUE));
         }
         break;
      case CHAR:
         if(value == MINVAL) {
           obj = (Object)(new Character(Character.MIN_VALUE)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Character(Character.MAX_VALUE));
         }
         break;
      case BOOLEAN:
         if(value == MINVAL) {
           obj = (Object)(new Boolean(true)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Boolean(false)); 
         }
         break;
      case BYTE:
         if(value == MINVAL) {
           obj = (Object)(new Byte(Byte.MIN_VALUE)); 
         }
         if(value == MAXVAL) {
           obj = (Object)(new Byte(Byte.MAX_VALUE));
         }
         break;
      }
      return (obj);
   }

   public String getObjectType(short type) {
      String objType = new String();
      switch(type) {
      case STRING:
         objType = "String";
         break;
      case SHORT:
         objType = "Short";
         break;
      case INT:
         objType = "Integer";
         break;
      case DOUBLE:
         objType = "Double";
         break;
      case FLOAT:
         objType = "Float";
         break;
      case LONG:
         objType = "Long";
         break;
      case CHAR:
         objType = "Character";
         break;
      case BOOLEAN:
         objType = "Boolean";
         break;
      case BYTE:
         objType = "Byte";
         break;
      }
      return (objType);
   } 
  
   public void evalTest() {
      System.out.println("==================================");
      try {
         win.eval("alert(\"This is a JSObject eval() test. >>>>>> TEST PASSED\")");
         win.eval("java.lang.System.out.println(\"This is a JSObject eval() test. >>>>>> TEST PASSED\")");
      } catch (Exception e) {
         System.out.println("!!!!!! Exception caught !!!!!!  " + e);
         System.out.println(">>>>>> TEST FAILED ");
      }
   }

   public void getMemberTest(String paramName) {
      System.out.println("==================================");
      try {
         String expValue = getParameter(paramName);
         if(expValue == null) {
            expValue = "Textbox Initial value.";
         }
         if (doc == null)
         {
           System.out.println("doc is NULL...");
           System.out.println(">>>>>> TEST FAILED >>>>>> ");
           return;
         }
         JSObject myForm = (JSObject)doc.getMember("testForm");
         if (myForm == null)
         {
           System.out.println("doc.getMember(testForm) is NULL...");
           System.out.println(">>>>>> TEST FAILED >>>>>> ");
           return;
         }
         JSObject myText = (JSObject)myForm.getMember("testText");
         if (myText == null)
         {
           System.out.println("myForm.getMember(testText) is NULL...");
           System.out.println(">>>>>> TEST FAILED >>>>>> ");
           return;
         }
         String txtValue = (String)myText.getMember("value");
         if(txtValue.equals(expValue)) {
            System.out.println("The textbox ACTUAL value is " + txtValue);
            System.out.println("The textbox EXPECTED value is " + expValue);
            System.out.println(">>>>>> TEST PASSED ");
         } else {
            System.out.println(">>>>>> TEST FAILED ");
         }
         Object args[] = {txtValue};
         win.call("popAlert", args); 
      } catch (Exception e) {
         System.out.println(" !!!!!! Exception caught !!!!!! " + e);
         System.out.println(">>>>>> TEST FAILED ");
      }
   }

   public void getSlotTest() {
      System.out.println("==================================");
      System.out.println("Inside getSlotTest ");
      int index = Integer.parseInt(getParameter("getSlotIndex"));
      String expName = getParameter("getSlotName");
      System.out.println("expName is " + expName);
      try {
         JSObject imgJSObject = (JSObject)doc.getMember("images");
         if (imgJSObject == null)
         {
           System.out.println("getMember(images) is NULL...");
           System.out.println(">>>>>> TEST FAILED >>>>>> ");
           return;
         }

         JSObject indexElement = (JSObject)imgJSObject.getSlot(index);
         //System.out.println("indexed element retrieved is " + indexElement);
         Object imgSrc = indexElement.getMember("src");
         //System.out.println("Image source is " + imgSrc);
         Object imgName = indexElement.getMember("name");
         //System.out.println("ACTUAL Image name is " + imgName);
         //System.out.println("EXPECTED Image name is " + expName);
         if(imgName.equals(expName)) {
            System.out.println(">>>>>> TEST PASSED ");
         } else {
            System.out.println(">>>>>> TEST FAILED ");
         }
            System.out.println("Returning ");
      } catch (Exception e) {
         System.out.println(" Exception caught " + e);
         System.out.println(">>>>>> TEST FAILED >>>>");
      }
   } 

   public void removeMemberTest() {
      System.out.println("==================================");
      try {
         JSObject myForm = (JSObject)doc.getMember("testForm");
         System.out.println("Removing the RemoveMember textbox object....");
         if (myForm == null)
         {
           System.out.println("getMember(testForm) is NULL...");
           System.out.println(">>>>>> TEST FAILED >>>>>> ");
           return;
         }

         myForm.removeMember("removeText");
         System.out.println("Finished removing the RemoveMember textbox object....");
         JSObject myText = (JSObject)myForm.getMember("removeText");
      } catch (ClassCastException e) {
         System.out.println("Couldn't find the removeMember textbox.");
         System.out.println(">>>>>> TEST PASSED ");
      } catch (Exception e) {
         System.out.println(" !!!!!! Exception caught !!!!!!" + e);
         System.out.println(">>>>>> TEST FAILED ");
      }
   }

   public void setMemberTest() {
      System.out.println("==================================");
      try {
         Object value = (Object) (new String("TextBox New Value set from the Applet."));  
         JSObject myForm = (JSObject)doc.getMember("testForm");
         if (myForm == null)
         {
           System.out.println("getMember(testForm) is NULL...");
           System.out.println(">>>>>> TEST FAILED >>>>>> ");
           return;
         }

         JSObject myText = (JSObject)myForm.getMember("testText");
         System.out.println("New string is " + value.toString());
         myText.setMember("value", value );
      } catch (Exception e) {
         System.out.println("!!!!!! Exception caught !!!!!!"  + e);
         System.out.println(">>>>>> TEST FAILED ");
      }
      getMemberTest("setMember");
   }

   public void setSlotTest() {
      System.out.println("==================================");
      int index = 2;
      try {
         JSObject imgJSObject = (JSObject)doc.getMember("images");
         if (imgJSObject == null)
         {
           System.out.println("doc.getMember(images) returned null " );
           System.out.println("TEST FAILED ");
           return;
         }
         Object newImg = win.getMember("imgObj"); 
         if (newImg == null)
         {
           System.out.println("win.getMember(imgObj) returned null " );
           System.out.println("TEST FAILED ");
           return;
         }
         imgJSObject.setSlot(index, newImg);
         JSObject newElement = (JSObject)imgJSObject.getSlot(index);
         if (newElement == null)
         {
           System.out.println("imgJSObject.getSlot(index) returned null " );
           System.out.println("TEST FAILED ");
           return;
         }
         Object imgWidth = newElement.getMember("width");
         System.out.println("Image width is " + imgWidth + "   of " + imgWidth.getClass());
         Object imgHeight = newElement.getMember("height");
         System.out.println("Image height is " + imgHeight + "   of " + imgHeight.getClass());
         String imgSrc = (String) newElement.getMember("src");
         System.out.println("ACTUAL Image source is " + imgSrc);
         String expValue = (String)win.getMember("imgSrc");
         System.out.println("EXPECTED Image source is " + expValue);
         if(imgSrc.lastIndexOf(expValue) != -1) {
            System.out.println(">>>>>> TEST PASSED ");
         } else {
            System.out.println(">>>>>> TEST FAILED ");
         }
      } catch (Exception e) {
         System.out.println("!!!!!! Exception caught !!!!!! " + e);
         System.out.println(">>>>>> TEST FAILED ****");
      }
   }

   public void toStringTest() {
      System.out.println("==================================");
      try {
         System.out.println("get Member testForm");
         JSObject myForm = (JSObject)doc.getMember("testForm");
         if (myForm == null)
         {
           System.out.println("getMember(myForm) is NULL...");
           System.out.println(">>>>>> TEST FAILED >>>>>> ");
         } else {
           System.out.println("\"testForm\" JSObject  == " + myForm.toString());
           System.out.println(">>>>>> TEST PASSED ");
         }
      } catch (Exception e) {
         System.out.println("!!!!!! Exception caught !!!!!!  " + e);
         System.out.println(">>>>>> TEST FAILED >>>>>> ");
      } 
   }

   public void paint(Graphics g) {
      setBackground(Color.yellow);
      g.setColor(Color.black);
      g.drawString(message, 15, 25);
   }
} 
